import * as plugins from '../plugins.js';
import * as data from '../data/index.js';
import * as userInterfaces from '../data/user.js';

export interface IReq_GetRegistryById extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_GetRegistryById
> {
  method: 'getExternalRegistryById';
  request: {
    identity: userInterfaces.IIdentity;
    id: string;
  };
  response: {
    registry: data.IExternalRegistry;
  };
}

export interface IReq_GetRegistries extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_GetRegistries
> {
  method: 'getExternalRegistries';
  request: {
    identity: userInterfaces.IIdentity;
  };
  response: {
    registries: data.IExternalRegistry[];
  };
}

export interface IReq_CreateRegistry extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_CreateRegistry
> {
  method: 'createExternalRegistry';
  request: {
    identity: userInterfaces.IIdentity;
    registryData: data.IExternalRegistry['data'];
  };
  response: {
    registry: data.IExternalRegistry;
  };
}

export interface IReq_UpdateRegistry extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_UpdateRegistry
> {
  method: 'updateExternalRegistry';
  request: {
    identity: userInterfaces.IIdentity;
    registryData: data.IExternalRegistry['data'];
  };
  response: {
    resultRegistry: data.IExternalRegistry;
  };
}

export interface IReq_DeleteRegistryById extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_DeleteRegistryById
> {
  method: 'deleteExternalRegistryById';
  request: {
    identity: userInterfaces.IIdentity;
    registryId: string;
  };
  response: {
    ok: boolean;
  };
}